using System;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.Text;

namespace MEdiaSpaceCore
{
    public class TcpServer
    {
        // Callback bits so the called can be informed of new connections
        public delegate void ClientConnectedHandler(TcpClient client);
        public event ClientConnectedHandler ClientConnected;

        private int _port;

        public TcpServer(int port)
        {
            _port = port;
        }

        public void Start()
        {
            TcpListener listener = new TcpListener(IPAddress.Any, _port);
            listener.Start();

            try
            {
                // Wait for a connection request and return a TcpClient initialized for communication
                TcpClient client = listener.AcceptTcpClient();

                // Echo this client connection to the handler
                if (ClientConnected != null)
                    ClientConnected(client);
            }
            catch (Exception err)
            {
                Console.WriteLine(err.Message);
            }
        }
    }
}
